VehicleFruitHorseHud = {};

function VehicleFruitHorseHud:loadHud()
	if g_currentMission.animalsManager ~= nil and g_currentMission.animalsManager.visualHorseRidingHud ~= nil and g_currentMission.animalsManager.visualHorseRidingHud then return false;end;
	VehicleFruitHud.horse = FillLevelsDisplay:new("dataS2/menu/hud/hud_elements_2160p.png");
	function getOptiWidthOverlay()	
		local width = g_currentMission.hud.fillLevelsDisplay.overlay.width;
		local horseDayRidingTxt = Utils.getNoNil(g_i18n:getText("ui_horseDailyRiding"), "Days Riding").. " ";
		local stringWidth = getTextWidth(g_currentMission.hud.fillLevelsDisplay.fillLevelTextSize, horseDayRidingTxt.. " 100%");
		local i = 0;	
		while width < stringWidth do
			i = i + 0.05;			
			width = g_currentMission.hud.fillLevelsDisplay.overlay.width+i;
		end;		
		return width;
	end;
	local overlayWidth = getOptiWidthOverlay();
	if VehicleFruitHud.overlays == nil then VehicleFruitHud.overlays = {};end;
	local _,isOkay1 = VehicleFruitHud:get_hl("getSetDefaultBackground", {VehicleFruitHud.overlays, "groundLine"}, "getSetDefaultBackground groundLine");
	local _,isOkay2 = VehicleFruitHud:get_hl("getSetDefaultBackground", {VehicleFruitHud.overlays, "groundProzentLine"}, "getSetDefaultBackground groundProzentLine");
	local _,isOkay3 = VehicleFruitHud:get_hl("setBackgroundColor", {VehicleFruitHud.overlays["groundLine"], {131/255,139/255,139/255,0.50}}, "setBackgroundLineColor groundLine");
	local _,isOkay4 = VehicleFruitHud:get_hl("setBackgroundColor", {VehicleFruitHud.overlays["groundProzentLine"], {255/255,65/255,0/255,1.00}}, "setBackgroundColor groundProzentLine");
	local _,isOkay5 = VehicleFruitHud:get_hl("getSetDefaultBackground", {VehicleFruitHud.overlays, "groundFruitHorse"}, "getSetDefaultBackground groundFruitHorse");
	local _,isOkay6 = VehicleFruitHud:get_hl("setBackgroundColor", {VehicleFruitHud.overlays["groundFruitHorse"], {0,0,0,0.50}}, "setBackgroundColor groundFruitHorse");
	VehicleFruitHud:get_hl("setOverlay", {VehicleFruitHud.overlays["groundLine"], 1.0-(overlayWidth*1.5),g_currentMission.hud.fillLevelsDisplay.origY,overlayWidth, 0.006}, "setOverlay BackgroundLine groundLine");
	VehicleFruitHud:get_hl("setOverlay", {VehicleFruitHud.overlays["groundProzentLine"], 1.0-(overlayWidth*1.5),g_currentMission.hud.fillLevelsDisplay.origY,0, 0.006}, "setOverlay BackgroundLine groundProzentLine");
	return isOkay1 and isOkay2 and isOkay3 and isOkay4 and isOkay5 and isOkay6;
end;

function VehicleFruitHorseHud:drawHud(vehicle)
	local frameHeight = g_currentMission.hud.fillLevelsDisplay.frameHeight;
	local size = g_currentMission.hud.fillLevelsDisplay.fillLevelTextSize;
	local txtHeight = getTextHeight(size, tostring("Gg"));
	local txtWidth = 0;
	local overlayWidth = VehicleFruitHud.overlays["groundLine"].width;
	local horseFitnessTxt = Utils.getNoNil(g_i18n:getText("ui_horseFitness"), "Fitness").. " ";
	local horseDayRidingTxt = Utils.getNoNil(g_i18n:getText("ui_horseDailyRiding"), "Days Riding").. " ";
	local horseTodayRidingTxt = "Today Riding  ";
	local horseCareTxt = Utils.getNoNil(g_i18n:getText("statistic_cleanliness"), "Care").. " ";
	local horseHealthTxt = "Health";
	local posX = 1.0-(overlayWidth*1.5);
	local posY = g_currentMission.hud.fillLevelsDisplay.origY;	
	
	VehicleFruitHud:get_hl("setOverlay", {VehicleFruitHud.overlays["groundFruitHorse"], posX-(overlayWidth*0.1),posY-(txtHeight*0.5),overlayWidth*1.2, posY+(txtHeight*16.5)}, "setOverlay Background drawHud groundFruitHorse");
	VehicleFruitHud.overlays["groundFruitHorse"]:render();	
	
	setTextColor(unpack(VehicleFruitHud.color));
	VehicleFruitHud:get_hl("setOverlay", {VehicleFruitHud.overlays["groundLine"], posX,posY,nil, nil}, "setOverlay BackgroundLine drawHud groundLine");
	local careScale = g_i18n:formatNumber(100-(Utils.getNoNil(Horse.getDirtScale(vehicle.spec_rideable.animal), 0)*100));
	setTextColor(unpack(VehicleFruitHud.color));	
	renderText(posX, posY+VehicleFruitHud.overlays["groundLine"].height+(txtHeight*0.5), size, tostring(horseCareTxt));
	txtWidth = getTextWidth(size, tostring(careScale).. "%");
	setTextColor(1,1,1,1);
	renderText(posX+VehicleFruitHud.overlays["groundLine"].width-txtWidth, posY+VehicleFruitHud.overlays["groundLine"].height+(txtHeight*0.5), size, tostring(careScale).. "%");
	if tonumber(careScale) > 100 then careScale = 100;end;
	VehicleFruitHud:get_hl("setOverlay", {VehicleFruitHud.overlays["groundProzentLine"], posX,posY,overlayWidth/100*careScale, nil}, "setOverlay BackgroundLine drawHud groundProzentLine");
	VehicleFruitHud.overlays["groundLine"]:render();
	VehicleFruitHud.overlays["groundProzentLine"]:render();
		
	posY = posY+(txtHeight*4);
	VehicleFruitHud:get_hl("setOverlay", {VehicleFruitHud.overlays["groundLine"], posX,posY,nil, nil}, "setOverlay BackgroundLine drawHud groundLine");
	local healthScale = g_i18n:formatNumber(Utils.getNoNil(Horse.getHealthScale(vehicle.spec_rideable.animal), 0)*100);
	setTextColor(unpack(VehicleFruitHud.color));
	renderText(posX, posY+VehicleFruitHud.overlays["groundLine"].height+(txtHeight*0.5), size, tostring(horseHealthTxt));
	txtWidth = getTextWidth(size, tostring(healthScale).. "%");
	setTextColor(1,1,1,1);
	renderText(posX+VehicleFruitHud.overlays["groundLine"].width-txtWidth, posY+VehicleFruitHud.overlays["groundLine"].height+(txtHeight*0.5), size, tostring(healthScale).. "%");
	if tonumber(healthScale) > 100 then healthScale = 100;end;
	VehicleFruitHud:get_hl("setOverlay", {VehicleFruitHud.overlays["groundProzentLine"], posX,posY,overlayWidth/100*healthScale, nil}, "setOverlay BackgroundLine drawHud groundProzentLine");
	VehicleFruitHud.overlays["groundLine"]:render();
	VehicleFruitHud.overlays["groundProzentLine"]:render();	
	
	posY = posY+(txtHeight*4);
	VehicleFruitHud:get_hl("setOverlay", {VehicleFruitHud.overlays["groundLine"], posX,posY,nil, nil}, "setOverlay BackgroundLine drawHud groundLine");
	local fitnessScale = g_i18n:formatNumber(Utils.getNoNil(Horse.getFitnessScale(vehicle.spec_rideable.animal), 0)*100);
	setTextColor(unpack(VehicleFruitHud.color));
	renderText(posX, posY+VehicleFruitHud.overlays["groundLine"].height+(txtHeight*0.5), size, tostring(horseFitnessTxt));
	txtWidth = getTextWidth(size, tostring(fitnessScale).. "%");
	setTextColor(1,1,1,1);
	renderText(posX+VehicleFruitHud.overlays["groundLine"].width-txtWidth, posY+VehicleFruitHud.overlays["groundLine"].height+(txtHeight*0.5), size, tostring(fitnessScale).. "%");
	VehicleFruitHud:get_hl("setOverlay", {VehicleFruitHud.overlays["groundProzentLine"], posX,posY,overlayWidth/100*fitnessScale, nil}, "setOverlay BackgroundLine drawHud groundProzentLine");
	VehicleFruitHud.overlays["groundLine"]:render();
	VehicleFruitHud.overlays["groundProzentLine"]:render();		
	
	posY = posY+(txtHeight*4);
	VehicleFruitHud:get_hl("setOverlay", {VehicleFruitHud.overlays["groundLine"], posX,posY,nil, nil}, "setOverlay BackgroundLine drawHud groundLine");
	local dayRidingTime = g_i18n:formatNumber(Utils.getNoNil(vehicle.spec_rideable.animal.ridingScale, 0)*100);	
	setTextColor(unpack(VehicleFruitHud.color));
	renderText(posX, posY+VehicleFruitHud.overlays["groundLine"].height+(txtHeight*0.5), size, tostring(horseDayRidingTxt));
	txtWidth = getTextWidth(size, tostring(dayRidingTime).. "%");
	setTextColor(1,1,1,1);
	renderText(posX+VehicleFruitHud.overlays["groundLine"].width-txtWidth, posY+VehicleFruitHud.overlays["groundLine"].height+(txtHeight*0.5), size, tostring(dayRidingTime).. "%");
	if tonumber(dayRidingTime) > 100 then dayRidingTime = 100;end;
	VehicleFruitHud:get_hl("setOverlay", {VehicleFruitHud.overlays["groundProzentLine"], posX,posY,overlayWidth/100*dayRidingTime, nil}, "setOverlay BackgroundLine drawHud groundProzentLine");
	VehicleFruitHud.overlays["groundLine"]:render();
	VehicleFruitHud.overlays["groundProzentLine"]:render();	
	
	posY = posY+(txtHeight*3);
	VehicleFruitHud:get_hl("setOverlay", {VehicleFruitHud.overlays["groundLine"], posX,posY,nil, nil}, "setOverlay BackgroundLine drawHud groundLine");
	local todaysRidingTime = Utils.getNoNil(Horse.getTodaysRidingTime(vehicle.spec_rideable.animal), 0);
	local nHours = string.format("%02.f", math.floor(todaysRidingTime/3600000));
	local nMins = string.format("%02.f", math.floor(todaysRidingTime/60000 - (nHours*60)));
	local todaysRidingTimeTemp = g_i18n:formatMinutes(tonumber(nMins));
	setTextColor(unpack(VehicleFruitHud.color));
	renderText(posX, posY+VehicleFruitHud.overlays["groundLine"].height, size, tostring(horseTodayRidingTxt));	
	VehicleFruitHud:get_hl("setOverlay", {VehicleFruitHud.overlays["groundProzentLine"], posX,posY,overlayWidth/2, nil}, "setOverlay BackgroundLine drawHud groundProzentLine");
	txtWidth = getTextWidth(size, tostring(todaysRidingTimeTemp));
	setTextColor(1,1,1,1);
	renderText(posX+VehicleFruitHud.overlays["groundLine"].width-txtWidth, posY+VehicleFruitHud.overlays["groundLine"].height, size, tostring(todaysRidingTimeTemp));
	posY = posY+(txtHeight*1);
	local horseName = tostring(vehicle.getName(vehicle):upper());
	renderText(posX, posY+VehicleFruitHud.overlays["groundLine"].height+(txtHeight*0.5), size+0.003, tostring(horseName));
	--local speed = VehicleFruitHorseHud:getSpeed(vehicle);
	--local speedTxt = tostring(g_i18n:getText("unit_kmh"));
	--if g_gameSettings:getValue('useMiles') then speedTxt = tostring(g_i18n:getText("unit_miles"));end;
	--txtWidth = getTextWidth(size, tostring(speed).. tostring(speedTxt));
	--if tonumber(speed) > 0 then
	--	renderText(posX, posY+VehicleFruitHud.overlays["groundLine"].height+(txtHeight*0.5), size, tostring(speed).. tostring(speedTxt));
	--end;	
end;

function VehicleFruitHorseHud:getSpeed(vehicle)
	local speed = Utils.getNoNil(vehicle.lastSpeed, 0)*3600;
	if g_gameSettings:getValue('useMiles') then speed = speed*0.621371;end;
	return string.format("%1.0f", "".. Utils.getNoNil(speed, 0));
end;
