VehicleFruitHud = {};
VehicleFruitHud.metadata = {
	interface = " FS19 ...",
	title = " VehicleFruit Hud",
	notes = " setzt Name/Prozent/Kapazität zusätzlich ins VehicleFruit Hud+Horse Riding Hud und ändert Schema",
	author = " (by HappyLooser)",
	version = " v0.5 Beta",	
	datum = " 20.11.2018",
	update = " 26.01.2019",
	web = " no",
	info = " Link Freigabe,Änderungen,Kopien oder Code Benutzung ist ohne meine Zustimmung nicht erlaubt",
	"##Orginal Link Freigabe:"
};

--0.5
--update
--fix VehicleFruitHud.name in XML wurde nicht beachtet
--New* performance check
VehicleFruitHud.modDir = g_currentModDirectory;
function VehicleFruitHud:loadMap(name)
	g_currentMission.vehicleFruitHud = VehicleFruitHud;	
	print("---loading".. tostring(VehicleFruitHud.metadata.title).. tostring(VehicleFruitHud.metadata.version).. tostring(VehicleFruitHud.metadata.author).. "---")
	if g_server ~= nil and g_client ~= nil and g_dedicatedServerInfo ~= nil then return;end;
	VehicleFruitHud.color = {255/255, 255/255,   0/255, 1.00};
	VehicleFruitHud.prozent = true;
	VehicleFruitHud.capacity = true;
	VehicleFruitHud.name = true;
	VehicleFruitHud.txtBold = true;
	VehicleFruitHud.txtSize = g_currentMission.hud.fillLevelsDisplay.fillLevelTextSize; --not active
	VehicleFruitHud.namePos = 1;
	VehicleFruitHud.lastSchemaX = 0;
	VehicleFruitHud.namePosAutoSize = false;
	VehicleFruitHud.schemaPos = 1;
	VehicleFruitHud.schemaOn = true;
	VehicleFruitHud.schemaZoom = 1.0;
	VehicleFruitHud.schemaFixY = 0.005000;
	VehicleFruitHud.schemaFixX = false;
	VehicleFruitHud.settingsDir = getUserProfileAppPath().. "modsSettings/VehicleFruitHud/";	
	VehicleFruitHud.hlDebugMode = false;
	VehicleFruitHud.visualFruitHorseHud = true;
	VehicleFruitHud.backgroundFruitHud = false;	
	if g_currentMission.vehicleInspector ~= nil and g_currentMission.vehicleInspector.vehicleSchema ~= nil and g_currentMission.vehicleInspector.vehicleSchema then VehicleFruitHud.schemaOn = false;end;
	VehicleFruitHud:setGetCfg(true);
	VehicleFruitHud:init();
	VehicleFruitHud.backgroundFruitHudLoad = VehicleFruitHud:loadBackground();
	if VehicleFruitHud.visualFruitHorseHud and not VehicleFruitHorseHud:loadHud() then VehicleFruitHud.visualFruitHorseHud = false;end;	
end;

function VehicleFruitHud:deleteMap()
	if g_server ~= nil and g_client ~= nil and g_dedicatedServerInfo ~= nil then return;end;
	VehicleFruitHud:setGetCfg(false);	
end;

function VehicleFruitHud:mouseEvent(posX, posY, isDown, isUp, button)
end;

function VehicleFruitHud:keyEvent(unicode, sym, modifier, isDown)
	if g_server ~= nil and g_client ~= nil and g_dedicatedServerInfo ~= nil then return;end;
	if VehicleFruitHud:get_hl("getIngameMap", {}, "getIngameMap") or VehicleFruitHud:get_hl("getFullSize", {true, false}, "getFullSize") then return;end;
	--set new rebootXmlESC
	if VehicleFruitHud.hlDebugMode and not VehicleFruitHud:get_hl("getFullSize", {true, true}, "getFullSize") and Input.isKeyPressed(Input.KEY_f2)then		
		if g_currentMission.hl.debug ~= nil then
			local a=1;		
			for key,value in pairs(g_currentMission.hl.debug) do
				for key1,value1 in pairs(value) do			
					print(tostring(a).. ".hl_Debug Error at ".. tostring(key).. " = ".. tostring(value1))			
					a=a+1;
				end;
			end;
		else
			print("1.hl_Debug NOT Found Error at ".. tostring(VehicleFruitHud.metadata.title))
		end;
	end;	
end;

function VehicleFruitHud:update(dt)	
	if g_server ~= nil and g_client ~= nil and g_dedicatedServerInfo ~= nil then return;end;
	if VehicleFruitHud:get_hl("getIngameMap", {}, "getIngameMap") or VehicleFruitHud:get_hl("getFullSize", {true, true}, "getFullSize") then return;end;
	if VehicleFruitHud.schemaOn and VehicleFruitHud.schemaPos > 1 and g_currentMission.hud.vehicleSchema.overlay.y > 0.7 then VehicleFruitHud:fixSchemaPos();end;
end;

function VehicleFruitHud:draw(dt)
	if g_server ~= nil and g_client ~= nil and g_dedicatedServerInfo ~= nil then return;end;	
	if VehicleFruitHud:get_hl("getIngameMap", {}, "getIngameMap") or VehicleFruitHud:get_hl("getFullSize", {true, true}, "getFullSize") then return;end;	
	local isControlled, vehicleRoot = g_currentMission.hl.isAvailable(g_currentMission.controlledVehicles, true);
	if g_currentMission.hud.fillLevelsDisplay.vehicle ~= nil and g_currentMission.hud.showVehicleSchema and isControlled then
		setTextAlignment(0);
		setTextColor(unpack(VehicleFruitHud.color));
		setTextBold(VehicleFruitHud.txtBold);
		local foundHorse = false;
		local vehicle = nil;
		if VehicleFruitHud.visualFruitHorseHud and vehicleRoot ~= nil and g_currentMission.nodeToObject[vehicleRoot] ~= nil then			
			vehicle = g_currentMission.nodeToObject[vehicleRoot];
			foundHorse = vehicle.specializationsByName ~= nil and vehicle.specializationsByName.rideable ~= nil and vehicle.spec_rideable ~= nil and vehicle.spec_rideable.animal ~= nil;
		end;
		if foundHorse then			
			VehicleFruitHorseHud:drawHud(vehicle);
		elseif g_currentMission.hud.fillLevelsDisplay.fillLevelBuffer ~= nil and type(g_currentMission.hud.fillLevelsDisplay.fillLevelBuffer) == "table" and #g_currentMission.hud.fillLevelsDisplay.fillLevelBuffer > 0 then
			local frameHeight = g_currentMission.hud.fillLevelsDisplay.frameHeight;
			if VehicleFruitHud.backgroundFruitHudLoad and VehicleFruitHud.backgroundFruitHud then
				local overlayHeight = frameHeight*(#g_currentMission.hud.fillLevelsDisplay.fillLevelBuffer)-(frameHeight/2.3);
				local posY = g_currentMission.hud.fillLevelsDisplay.origY;
				VehicleFruitHud:get_hl("setOverlay", {VehicleFruitHud.overlays["groundFruitHud"], g_currentMission.hud.fillLevelsDisplay.origX,posY,g_currentMission.hud.fillLevelsDisplay.overlay.width, overlayHeight}, "setOverlay BackgroundFruitHud");
				VehicleFruitHud.overlays["groundFruitHud"]:render();				
			end;
			for a=1, #g_currentMission.hud.fillLevelsDisplay.fillLevelBuffer do
				if g_currentMission.hud.fillLevelsDisplay.fillLevelBuffer[a] ~= nil then					
					local capacity = g_currentMission.hud.fillLevelsDisplay.fillLevelBuffer[a].capacity or 0;
					local fillType = g_currentMission.hud.fillLevelsDisplay.fillLevelBuffer[a].fillType or 0;
					local fillLevel = g_currentMission.hud.fillLevelsDisplay.fillLevelBuffer[a].fillLevel or 0;
					local percent = VehicleFruitHud:get_hl("getProzentFillLevel", {fillLevel, capacity, true}, "Vehicel FillLevel/Capacity ProzentString"); 
					--local descFruit = g_currentMission.fruitTypeManager.fruitTypes[fillType]; --later fruitTypeIndexToFillType a test convertFruitViaFill
					local descFill = g_currentMission.fillTypeManager.fillTypes[fillType];
					if descFruit ~= nil and descFill ~= nil then 
						--if descFruit ~= descFill then descFill = descFruit;end;
					end;
					if descFill ~= nil then						
						local name = descFill.title or descFill.name;
						local txtHeight = getTextHeight(g_currentMission.hud.fillLevelsDisplay.fillLevelTextSize, tostring("Gg"));
						if capacity > 0 then 
							setTextAlignment(2);
							if VehicleFruitHud.capacity then 
								if VehicleFruitHud.namePos == 3 then
									renderText(g_currentMission.hud.fillLevelsDisplay.origX+g_currentMission.hud.fillLevelsDisplay.overlay.width, g_currentMission.hud.fillLevelsDisplay.origY+(frameHeight*(a-1))+txtHeight*2.5, g_currentMission.hud.fillLevelsDisplay.fillLevelTextSize, tostring(capacity));
								elseif VehicleFruitHud.namePos ~= 5 then
									renderText(g_currentMission.hud.fillLevelsDisplay.origX+g_currentMission.hud.fillLevelsDisplay.overlay.width, g_currentMission.hud.fillLevelsDisplay.origY+(frameHeight*(a-1))-txtHeight, g_currentMission.hud.fillLevelsDisplay.fillLevelTextSize, tostring(capacity));
								end;
							end;
						
							if fillLevel > 0 then 
								setTextAlignment(0);
								if VehicleFruitHud.prozent then 
									if VehicleFruitHud.namePos == 3 or VehicleFruitHud.namePos == 5 then
										setTextAlignment(0);
										renderText(g_currentMission.hud.fillLevelsDisplay.origX+(g_currentMission.hud.fillLevelsDisplay.overlay.width/5), g_currentMission.hud.fillLevelsDisplay.origY+(frameHeight*(a-1))+txtHeight*1.5, g_currentMission.hud.fillLevelsDisplay.fillLevelTextSize, tostring(percent).. "%");
									else
										renderText(g_currentMission.hud.fillLevelsDisplay.origX+(g_currentMission.hud.fillLevelsDisplay.overlay.width/5), g_currentMission.hud.fillLevelsDisplay.origY+(frameHeight*(a-1))-txtHeight, g_currentMission.hud.fillLevelsDisplay.fillLevelTextSize, tostring(percent).. "%");
									end;
								end;
							end;
						end;
						if VehicleFruitHud.name and not string.find(name, "Unknown") then
							if VehicleFruitHud.namePos == 1 then
								setTextAlignment(2);
								renderText(g_currentMission.hud.fillLevelsDisplay.origX, g_currentMission.hud.fillLevelsDisplay.origY+(frameHeight*(a-1)), g_currentMission.hud.fillLevelsDisplay.fillLevelTextSize, tostring(name));
							elseif VehicleFruitHud.namePos == 2 then
								local optiSize = VehicleFruitHud:getOptimalSize(g_currentMission.hud.fillLevelsDisplay.overlay.width-getTextWidth(g_currentMission.hud.fillLevelsDisplay.fillLevelTextSize, tostring(string.format("%1.f", "".. fillLevel))), tostring(name), g_currentMission.hud.fillLevelsDisplay.fillLevelTextSize);
								if not VehicleFruitHud.namePosAutoSize then optiSize = g_currentMission.hud.fillLevelsDisplay.fillLevelTextSize;end;
								setTextAlignment(0);
								renderText(g_currentMission.hud.fillLevelsDisplay.origX+(g_currentMission.hud.fillLevelsDisplay.overlay.width/5), g_currentMission.hud.fillLevelsDisplay.origY+(frameHeight*(a-1))+txtHeight*1.5, optiSize, tostring(name));
							elseif VehicleFruitHud.namePos == 3 then
								setTextAlignment(0);
								renderText(g_currentMission.hud.fillLevelsDisplay.origX+(g_currentMission.hud.fillLevelsDisplay.overlay.width/5), g_currentMission.hud.fillLevelsDisplay.origY+(frameHeight*(a-1))-txtHeight, g_currentMission.hud.fillLevelsDisplay.fillLevelTextSize, tostring(name));
							elseif VehicleFruitHud.namePos == 4 or VehicleFruitHud.namePos == 5 then
								local optiSize = VehicleFruitHud:getOptimalSize(g_currentMission.hud.fillLevelsDisplay.overlay.width-getTextWidth(g_currentMission.hud.fillLevelsDisplay.fillLevelTextSize, tostring(capacity)), tostring(name), g_currentMission.hud.fillLevelsDisplay.fillLevelTextSize);
								if VehicleFruitHud.namePos == 4 or not VehicleFruitHud.namePosAutoSize then optiSize = g_currentMission.hud.fillLevelsDisplay.fillLevelTextSize;end;
								setTextAlignment(0);
								renderText(g_currentMission.hud.fillLevelsDisplay.origX+(g_currentMission.hud.fillLevelsDisplay.overlay.width/5), g_currentMission.hud.fillLevelsDisplay.origY+(frameHeight*(a-1))+txtHeight*2.5, optiSize, tostring(name));
								if VehicleFruitHud.namePos == 5 then
									if VehicleFruitHud.capacity and capacity > 0 then 
										setTextAlignment(2);
										renderText(g_currentMission.hud.fillLevelsDisplay.origX+g_currentMission.hud.fillLevelsDisplay.overlay.width, g_currentMission.hud.fillLevelsDisplay.origY+(frameHeight*(a-1))+txtHeight*2.5, g_currentMission.hud.fillLevelsDisplay.fillLevelTextSize, tostring(capacity));
									end;									
								end;								
							end;
						end;
					end;					
				end;				
			end;			
		end;
		if VehicleFruitHud.schemaOn and VehicleFruitHud.schemaPos > 3 and g_currentMission.hud.vehicleSchema.overlay.y > 0.7 then VehicleFruitHud:fixSchemaPos();end;	
	end;
	--respect settings for other mods
	setTextAlignment(0);
	setTextColor(1, 1, 1, 1);
	setTextBold(false);
	--respect settings for other mods
end;
addModEventListener(VehicleFruitHud);

--function VehicleFruitHud:getProzentFillLevelString(fillLevel, capacity)
--	if type(capacity) ~= "number" or type(fillLevel) ~= "number" or capacity <= 0 or then return "0";end;
--	return string.format("%1.0f", "".. tonumber(fillLevel)/tonumber(capacity)*100);
--end;


function VehicleFruitHud:get_hl(args, argsTable, errorTxtCall) --args hl table, argsTable a table with all args Values, errorTxt a Value for debug print
	local isOkay, result, argsError, errorTxt = nil,nil,nil,errorTxtCall;
	if VehicleFruitHud.hlDebugMode and (errorTxtCall == nil or type(errorTxtCall) ~= "string" or string.len(errorTxtCall) == 0) then errorTxt = "Unknown";end;
	local foundArgsError = false;
	if type(argsTable) == "table" or g_currentMission.hl[args] ~= nil or #argsTable > 0 then	
		isOkay, result = pcall(g_currentMission.hl[args], unpack(argsTable));
	else
		foundArgsError = true;
	end;
	if VehicleFruitHud.hlDebugMode and foundArgsError then isOkay=false;argsError="Unknown args or argsTable or argsTable = 0";end;		
	if VehicleFruitHud.hlDebugMode and (not isOkay or foundArgsError) then VehicleFruitHud:setDebug("VehicleFruitHudMod", args or "Unknown", errorTxt, argsError or "No args error", result or "NO result error");end;
	return result, isOkay;	
end;

function VehicleFruitHud:setDebug(argsMod, args1, errorTxt, args2, args3)	
	if g_currentMission.hl.debug == nil then g_currentMission.hl.debug = {};end;
	if g_currentMission.hl.debug[argsMod] == nil then g_currentMission.hl.debug[argsMod] = {};end;
	local errorString = "Trigger: ".. tostring(args1).. " -errorTxtCall: ".. tostring(errorTxt).. " -argsError: ".. tostring(args2).. " -resultError: ".. tostring(args3);
	local alreadyExists = false;
	if #g_currentMission.hl.debug[argsMod] == 0 then table.insert(g_currentMission.hl.debug[argsMod], tostring(errorString));else
		for key,value in pairs(g_currentMission.hl.debug[argsMod]) do			
			if tostring(value) == errorString and string.len(value) == string.len(errorString) then alreadyExists=true;break;end;			
		end;		
		if not alreadyExists then table.insert(g_currentMission.hl.debug[argsMod], tostring(errorString));end;
	end;	
end;

function VehicleFruitHud:setGetCfg(loadCfg)
	createFolder(getUserProfileAppPath().. "modsSettings/");
	createFolder(VehicleFruitHud.settingsDir);
	local file = VehicleFruitHud.settingsDir.. "vehicleFruitHudSettings.xml";
	local Xml = nil;
	if not fileExists(file) or not loadCfg then
		Xml = createXMLFile("VehicleFruitHud_XML", file, "vehicleFruitHudSettings");
		local groupNameTag = ("vehicleFruitHudSettings.global(%d)"):format(0);
		setXMLBool(Xml, groupNameTag.. "#prozent", VehicleFruitHud.prozent);
		setXMLBool(Xml, groupNameTag.. "#capacity", VehicleFruitHud.capacity);
		setXMLBool(Xml, groupNameTag.. "#name", VehicleFruitHud.name);
		setXMLBool(Xml, groupNameTag.. "#txtBold", VehicleFruitHud.txtBold);
		setXMLBool(Xml, groupNameTag.. "#namePosAutoSize", VehicleFruitHud.namePosAutoSize);
		setXMLInt(Xml, groupNameTag.. "#namePos", VehicleFruitHud.namePos);
		setXMLFloat(Xml, groupNameTag.. "#colorR", VehicleFruitHud.color[1]);
		setXMLFloat(Xml, groupNameTag.. "#colorG", VehicleFruitHud.color[2]);
		setXMLFloat(Xml, groupNameTag.. "#colorB", VehicleFruitHud.color[3]);
		setXMLFloat(Xml, groupNameTag.. "#colorA", VehicleFruitHud.color[4]);
		setXMLFloat(Xml, groupNameTag.. "#schemaZoom", VehicleFruitHud.schemaZoom);
		setXMLFloat(Xml, groupNameTag.. "#schemaFixY", VehicleFruitHud.schemaFixY);
		setXMLBool(Xml, groupNameTag.. "#schemaFixX", VehicleFruitHud.schemaFixX);
		setXMLInt(Xml, groupNameTag.. "#schemaPos", VehicleFruitHud.schemaPos);
		setXMLBool(Xml, groupNameTag.. "#hlDebugMode", VehicleFruitHud.hlDebugMode);
		setXMLBool(Xml, groupNameTag.. "#visualFruitHorseHud", VehicleFruitHud.visualFruitHorseHud);
		--setXMLBool(Xml, groupNameTag.. "#backgroundFruitHud", VehicleFruitHud.backgroundFruitHud);
		saveXMLFile(Xml);
	else	
		Xml = loadXMLFile("VehicleFruitHud_XML", file, "vehicleFruitHudSettings");
		local groupNameTag = ("vehicleFruitHudSettings.global(%d)"):format(0);
		if getXMLBool(Xml, groupNameTag.. "#prozent") ~= nil then VehicleFruitHud.prozent = getXMLBool(Xml, groupNameTag.. "#prozent");end;
		if getXMLBool(Xml, groupNameTag.. "#capacity") ~= nil then VehicleFruitHud.capacity = getXMLBool(Xml, groupNameTag.. "#capacity");end;
		if getXMLBool(Xml, groupNameTag.. "#name") ~= nil then VehicleFruitHud.name = getXMLBool(Xml, groupNameTag.. "#name");end;
		if getXMLBool(Xml, groupNameTag.. "#txtBold") ~= nil then VehicleFruitHud.txtBold = getXMLBool(Xml, groupNameTag.. "#txtBold");end;
		if getXMLBool(Xml, groupNameTag.. "#namePosAutoSize") ~= nil then VehicleFruitHud.namePosAutoSize = getXMLBool(Xml, groupNameTag.. "#namePosAutoSize");end;
		if getXMLInt(Xml, groupNameTag.. "#namePos") then VehicleFruitHud.namePos = getXMLInt(Xml, groupNameTag.. "#namePos");end;
		if getXMLFloat(Xml, groupNameTag.. "#colorR") then VehicleFruitHud.color[1] = getXMLFloat(Xml, groupNameTag.. "#colorR");end;
		if getXMLFloat(Xml, groupNameTag.. "#colorG") then VehicleFruitHud.color[2] = getXMLFloat(Xml, groupNameTag.. "#colorG");end;
		if getXMLFloat(Xml, groupNameTag.. "#colorB") then VehicleFruitHud.color[3] = getXMLFloat(Xml, groupNameTag.. "#colorB");end;
		if getXMLFloat(Xml, groupNameTag.. "#colorA") then VehicleFruitHud.color[4] = getXMLFloat(Xml, groupNameTag.. "#colorA");end;
		if getXMLInt(Xml, groupNameTag.. "#schemaPos") then VehicleFruitHud.schemaPos = getXMLInt(Xml, groupNameTag.. "#schemaPos");end;
		if getXMLFloat(Xml, groupNameTag.. "#schemaZoom") then VehicleFruitHud.schemaZoom = getXMLFloat(Xml, groupNameTag.. "#schemaZoom");end;	
		if getXMLFloat(Xml, groupNameTag.. "#schemaFixY") then VehicleFruitHud.schemaFixY = getXMLFloat(Xml, groupNameTag.. "#schemaFixY");end;
		if getXMLBool(Xml, groupNameTag.. "#schemaFixX") ~= nil then VehicleFruitHud.schemaFixX = getXMLBool(Xml, groupNameTag.. "#schemaFixX");end;
		if getXMLBool(Xml, groupNameTag.. "#hlDebugMode") ~= nil then VehicleFruitHud.hlDebugMode = getXMLBool(Xml, groupNameTag.. "#hlDebugMode");end;
		if getXMLBool(Xml, groupNameTag.. "#visualFruitHorseHud") ~= nil then VehicleFruitHud.visualFruitHorseHud = getXMLBool(Xml, groupNameTag.. "#visualFruitHorseHud");end;
		--if getXMLBool(Xml, groupNameTag.. "#backgroundFruitHud") ~= nil then VehicleFruitHud.backgroundFruitHud = getXMLBool(Xml, groupNameTag.. "#backgroundFruitHud");end;
	end;
	if loadCfg then
		if VehicleFruitHud.schemaOn and (VehicleFruitHud.schemaPos > 1 or VehicleFruitHud.schemaZoom > 1.0 or VehicleFruitHud.schemaZoom < 1.0) then
			local tempHeight = 0;
			for key, value in pairs(g_currentMission.hud.vehicleSchema.vehicleSchemaOverlays) do
				tempHeight = (value.height*VehicleFruitHud.schemaZoom)-value.height
				value.height = value.height*VehicleFruitHud.schemaZoom;
				value.width = value.width*VehicleFruitHud.schemaZoom;
				if VehicleFruitHud.schemaPos == 1 then
					value.y = value.y+tempHeight; --default oben
				elseif VehicleFruitHud.schemaPos == 2 then
					g_currentMission.hud.vehicleSchema.overlay.y = 0.001+VehicleFruitHud.schemaFixY; --+(tempHeight/2);
					g_currentMission.hud.vehicleSchema.overlay.x = 0.98-g_currentMission.hud.vehicleSchema.maxSchemaWidth;			
					value.x = 0.98-g_currentMission.hud.vehicleSchema.maxSchemaWidth;
					value.y = 0.001+VehicleFruitHud.schemaFixY;
				elseif VehicleFruitHud.schemaPos == 3 then
					g_currentMission.hud.vehicleSchema.overlay.x = 0.98-g_currentMission.hud.vehicleSchema.maxSchemaWidth;					
					for key, value in pairs(g_currentMission.hud.displayComponents) do
						if g_currentMission.hud.displayComponents[key].gaugeBackgroundElement ~= nil and g_currentMission.hud.displayComponents[key].gaugeCenterY ~= nil then
							g_currentMission.hud.vehicleSchema.overlay.y = g_currentMission.hud.displayComponents[key].gaugeCenterY+(g_currentMission.hud.displayComponents[key].gaugeBackgroundElement.overlay.height/1.5)+VehicleFruitHud.schemaFixY;
							break;
						end;
					end;
				end;
				--value.y = 0.025925925925926 --unten operatingTimeTextDrawPositionY
				--value.x = 0.96034617074377 --unten operatingTimeTextDrawPositionX
			end;	
		end;
	end;
end;

function VehicleFruitHud:loadBackground()
	if VehicleFruitHud.overlays == nil then VehicleFruitHud.overlays = {};end;
	local _,isOkay1 = VehicleFruitHud:get_hl("getSetDefaultBackground", {VehicleFruitHud.overlays, "groundFruitHud"}, "getSetDefaultBackground groundFruitHud");
	local _,isOkay2 = VehicleFruitHud:get_hl("setBackgroundColor", {VehicleFruitHud.overlays["groundFruitHud"], {0,0,0,0.70}}, "setBackgroundColor groundFruitHud");
	return isOkay1 and isOkay2;
end;

function VehicleFruitHud:init()
	VehicleFruitHud:setGetCfg(false);
	source(VehicleFruitHud.modDir.."_hl.lua");
	source(VehicleFruitHud.modDir.."VehicleFruitHorseHud.lua");	
end;

function VehicleFruitHud:getOptimalSize(width, txtString, defaultSize)
	local length = getTextWidth(defaultSize, tostring(txtString));
	local default = defaultSize;
	if length > width then
		local i = 0;
		while length > width do
			i = i + 0.0005;
			length = getTextWidth(defaultSize-i, tostring(txtString));
		end
		return defaultSize-i;
	end;
	return default;
end;

function VehicleFruitHud:fixSchemaPos() --not ideal solution, is Slide Effect
	if VehicleFruitHud.schemaFixX then 
		---new for slide X Effect, to testing
		if VehicleFruitHud.lastSchemaX <=0 then VehicleFruitHud.lastSchemaX = 0.098-g_currentMission.hud.vehicleSchema.maxSchemaWidth;end;
		if VehicleFruitHud.schemaPos == 2 then
			g_currentMission.hud.vehicleSchema.overlay.y = 0.001+VehicleFruitHud.schemaFixY; --+(tempHeight/2);
			--local width = g_currentMission.hud.vehicleSchema.maxSchemaWidth;			
			--if not g_gameSettings:getValue("showHelpMenu") then width = width/2;end;
			--local tempNewX = 0.98-width;
			--if tempNewX > VehicleFruitHud.lastSchemaX then g_currentMission.hud.vehicleSchema.overlay.x = tempNewX else
			--g_currentMission.hud.vehicleSchema.overlay.x = 0.98-width;VehicleFruitHud.lastSchemaX = 0.98-width;end;	
			for key, value in pairs(g_currentMission.hud.displayComponents) do
				if g_currentMission.hud.displayComponents[key].gaugeBackgroundElement ~= nil then
					if not g_gameSettings:getValue("showHelpMenu") then
						g_currentMission.hud.vehicleSchema.overlay.x = 0.96;
					else
						g_currentMission.hud.vehicleSchema.overlay.x = 0.96-(g_currentMission.hud.displayComponents[key].gaugeBackgroundElement.overlay.width/2);
					end;
					break;
				end;
			end;

			
		elseif VehicleFruitHud.schemaPos == 3 then			
			g_currentMission.hud.vehicleSchema.overlay.x = 0.96		
			for key, value in pairs(g_currentMission.hud.displayComponents) do
				if g_currentMission.hud.displayComponents[key].gaugeBackgroundElement ~= nil and g_currentMission.hud.displayComponents[key].gaugeCenterY ~= nil then
					g_currentMission.hud.vehicleSchema.overlay.y = g_currentMission.hud.displayComponents[key].gaugeCenterY+(g_currentMission.hud.displayComponents[key].gaugeBackgroundElement.overlay.height/1.5)+VehicleFruitHud.schemaFixY;
					if not g_gameSettings:getValue("showHelpMenu") then
						g_currentMission.hud.vehicleSchema.overlay.x = 0.96;
					else
						g_currentMission.hud.vehicleSchema.overlay.x = 0.96-(g_currentMission.hud.displayComponents[key].gaugeBackgroundElement.overlay.width/2);
					end;
					break;
				end;
			end;
		end;				
	else
		VehicleFruitHud:fixSchemaPosOld()
	end;
end;

function VehicleFruitHud:fixSchemaPosOld() --not ideal solution, is Slide Effect	
	if VehicleFruitHud.schemaPos == 2 then
		g_currentMission.hud.vehicleSchema.overlay.y = 0.001+VehicleFruitHud.schemaFixY; --+(tempHeight/2);
		g_currentMission.hud.vehicleSchema.overlay.x = 0.98-g_currentMission.hud.vehicleSchema.maxSchemaWidth;			
	elseif VehicleFruitHud.schemaPos == 3 then
		g_currentMission.hud.vehicleSchema.overlay.x = 0.98-g_currentMission.hud.vehicleSchema.maxSchemaWidth;					
		for key, value in pairs(g_currentMission.hud.displayComponents) do
			if g_currentMission.hud.displayComponents[key].gaugeBackgroundElement ~= nil and g_currentMission.hud.displayComponents[key].gaugeCenterY ~= nil then
				g_currentMission.hud.vehicleSchema.overlay.y = g_currentMission.hud.displayComponents[key].gaugeCenterY+(g_currentMission.hud.displayComponents[key].gaugeBackgroundElement.overlay.height/1.5)+VehicleFruitHud.schemaFixY;
				break;
			end;
		end;
	end;
end;